<?php

namespace dgsoft\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfProfilesTypeProfileInfo1 ArrayType
 * @package Dg
 * @subpackage Arrays
 */
class DgArrayOfProfilesTypeProfileInfo1 extends AbstractStructArrayBase
{
    /**
     * The ProfilesTypeProfileInfo
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \dgsoft\StructType\DgProfilesTypeProfileInfo[]
     */
    public $ProfilesTypeProfileInfo;
    /**
     * Constructor method for ArrayOfProfilesTypeProfileInfo1
     * @uses DgArrayOfProfilesTypeProfileInfo1::setProfilesTypeProfileInfo()
     * @param \dgsoft\StructType\DgProfilesTypeProfileInfo[] $profilesTypeProfileInfo
     */
    public function __construct(array $profilesTypeProfileInfo = array())
    {
        $this
            ->setProfilesTypeProfileInfo($profilesTypeProfileInfo);
    }
    /**
     * Get ProfilesTypeProfileInfo value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \dgsoft\StructType\DgProfilesTypeProfileInfo[]|null
     */
    public function getProfilesTypeProfileInfo()
    {
        return isset($this->ProfilesTypeProfileInfo) ? $this->ProfilesTypeProfileInfo : null;
    }
    /**
     * Set ProfilesTypeProfileInfo value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \dgsoft\StructType\DgProfilesTypeProfileInfo[] $profilesTypeProfileInfo
     * @return \dgsoft\ArrayType\DgArrayOfProfilesTypeProfileInfo1
     */
    public function setProfilesTypeProfileInfo(array $profilesTypeProfileInfo = array())
    {
        foreach ($profilesTypeProfileInfo as $arrayOfProfilesTypeProfileInfo1ProfilesTypeProfileInfoItem) {
            // validation for constraint: itemType
            if (!$arrayOfProfilesTypeProfileInfo1ProfilesTypeProfileInfoItem instanceof \dgsoft\StructType\DgProfilesTypeProfileInfo) {
                throw new \InvalidArgumentException(sprintf('The ProfilesTypeProfileInfo property can only contain items of \dgsoft\StructType\DgProfilesTypeProfileInfo, "%s" given', is_object($arrayOfProfilesTypeProfileInfo1ProfilesTypeProfileInfoItem) ? get_class($arrayOfProfilesTypeProfileInfo1ProfilesTypeProfileInfoItem) : gettype($arrayOfProfilesTypeProfileInfo1ProfilesTypeProfileInfoItem)), __LINE__);
            }
        }
        if (is_null($profilesTypeProfileInfo) || (is_array($profilesTypeProfileInfo) && empty($profilesTypeProfileInfo))) {
            unset($this->ProfilesTypeProfileInfo);
        } else {
            $this->ProfilesTypeProfileInfo = $profilesTypeProfileInfo;
        }
        return $this;
    }
    /**
     * Add item to ProfilesTypeProfileInfo value
     * @throws \InvalidArgumentException
     * @param \dgsoft\StructType\DgProfilesTypeProfileInfo $item
     * @return \dgsoft\ArrayType\DgArrayOfProfilesTypeProfileInfo1
     */
    public function addToProfilesTypeProfileInfo(\dgsoft\StructType\DgProfilesTypeProfileInfo $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \dgsoft\StructType\DgProfilesTypeProfileInfo) {
            throw new \InvalidArgumentException(sprintf('The ProfilesTypeProfileInfo property can only contain items of \dgsoft\StructType\DgProfilesTypeProfileInfo, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->ProfilesTypeProfileInfo[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \dgsoft\StructType\DgProfilesTypeProfileInfo|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \dgsoft\StructType\DgProfilesTypeProfileInfo|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \dgsoft\StructType\DgProfilesTypeProfileInfo|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \dgsoft\StructType\DgProfilesTypeProfileInfo|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \dgsoft\StructType\DgProfilesTypeProfileInfo|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ProfilesTypeProfileInfo
     */
    public function getAttributeName()
    {
        return 'ProfilesTypeProfileInfo';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \dgsoft\ArrayType\DgArrayOfProfilesTypeProfileInfo1
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
